/////////////////////////////////////////////////////////////////////////////////
//
//  FeatureChromAbber: definuje efekt chromatickej aberacie
//
/////////////////////////////////////////////////////////////////////////////////

#pragma once

#include "feature.h"
#include "initgrid.h"
#include "distortionwarpfunctor.h"

class FeatureChromAbber: public Feature
{
	typedef std::vector<float> vecF_t;
	PtrHDRImage1f m_gridXred, m_gridYred;
	PtrHDRImage1f m_gridXblue, m_gridYblue;

public:
	FeatureChromAbber (PtrFuncFtoF funcRedcyan, PtrFuncFtoF funcBlueyellow, uint2 sizeOfGrid, float2 aspectratio)
	{
		m_gridXred = PtrHDRImage1f (new HDRImage1f);
		m_gridYred = PtrHDRImage1f (new HDRImage1f);
		m_gridXblue = PtrHDRImage1f (new HDRImage1f);
		m_gridYblue = PtrHDRImage1f (new HDRImage1f);

		initGrid (m_gridXred, m_gridYred, sizeOfGrid, aspectratio, funcRedcyan.get());
		initGrid (m_gridXblue, m_gridYblue, sizeOfGrid, aspectratio, funcBlueyellow.get());
	}
	type getType ()
	{
		return FEATURE_3F_TO_3F;
	}
	void featureFtoF (PtrHDRImage3f in, PtrHDRImage3f &out)
	{
		out = in;
	
		DistortionWarpFunctor functorR (in, m_gridXred, m_gridYred);
		DistortionWarpFunctor functorB (in, m_gridXblue, m_gridYblue);
		functorR.apply (0);
		//functorB.apply (1);
	}
};