#pragma once

#include "featureconstmult.h"
#include "func.h"



class FeatureVignettingMask: public Feature
{
	std::string m_pathMask;
	PtrHDRImage3f m_mask;
public:
	void initMask (uint2 size)
	{
		if (m_mask.get()!=NULL && m_mask->getSize() == size)
			return;
		m_mask = PtrHDRImage3f (new HDRImage3f (size));
		HDRImage3f loader;
		loader.loadFromFile (m_pathMask.c_str());
		loader.getSubImage (m_mask, size, float2(0,0), float2(0,0));
	}
	FeatureVignettingMask (std::string path, uint2 defaultSize)
	{
		m_pathMask = path;
		initMask (defaultSize);
	}
	type getType ()
	{
		return FEATURE_3F_TO_3F;
	}
	void featureFtoF (PtrHDRImage3f in, PtrHDRImage3f &out)
	{
		out = in;
		HDRIFunctorMultByHDRI3f functor (in->getMult(), m_mask);
		in->applyFunctor (functor);
	}
};